/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.sun.mojarra.scales.component;

import com.sun.mojarra.scales.util.ScalesUtil;
import com.sun.mojarra.scales.util.YuiConstants;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;
import javax.el.ValueExpression;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;

/**
 *
 * @author Jason Lee
 */
public class Links extends UIOutput {

    public static final String COMPONENT_FAMILY = "com.sun.mojarra.scales.Links";
    public static final String COMPONENT_TYPE = COMPONENT_FAMILY;
    public static final String RENDERER_TYPE = COMPONENT_FAMILY;
    public static final String EXTERNAL_SCRIPTS = "SCALES_EXTERNAL_SCRIPTS";
    public static final String DOM_READY_SCRIPTS = "SCALES_DOM_READY_SCRIPTS";
    public static final String EXTERNAL_STYLESHEETS = "SCALES_EXTERNAL_STYLESHEETS";
    public static final String INLINE_STYLESHEET = "SCALES_INLINE_STYLESHEET";
    public static final String META_TAGS = "SCALES_META_TAGS";

    public Links() {
        super();
        setRendererType(RENDERER_TYPE);
        FacesContext context = FacesContext.getCurrentInstance();
        if (context == null) {
            return;
        }
        String baseUrl = context.getExternalContext().getRequestContextPath();
        if ("-debug".equals(YuiConstants.YUI_SUFFIX)) {
            // Base Scripts, found in utilities
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_YAHOO));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_EVENT));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_DOM));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_CONNECTION_MANAGER));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_ANIMATION));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_DRAGDROP));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_ELEMENT));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_GET));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_LOADER));

            // Additional debug items
        } else {
            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_SCALES));
            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_UTILITES));
//            addScript(EXTERNAL_SCRIPTS, baseUrl + ScalesUtil.createResourceUrl(context, YuiConstants.JS_LOGGER));
        }

        // We'll almost always need this, so, for now...
        addCss(EXTERNAL_STYLESHEETS, baseUrl+ScalesUtil.createResourceUrl(context, YuiConstants.CSS_SKIN_SAM));
        addScript(DOM_READY_SCRIPTS, "YAHOO.util.Dom.addClass(document.body, \"yui-skin-sam\");");
        ValueExpression ve = ScalesUtil.createValueExpression("#{baseUrl}", String.class);
        ve.setValue(context.getELContext(), ScalesUtil.getStaticResourceUrl(context, ""));
    }

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    /**
     * The ID of the component
     */
    @Override
    //@Property(name = "id", isAttribute = true)
    public void setId(String id) {
        super.setId(id);
    }

    /**
     * Should be set to false if the component should not be rendered
     */
    @Override
    //@Property(name = "rendered", isAttribute = true)
    public void setRendered(boolean rendered) {
        super.setRendered(rendered);
    }

    @SuppressWarnings("unchecked")
    public static Set<String> getScripts(String type) {
        if (!EXTERNAL_SCRIPTS.equals(type) && !DOM_READY_SCRIPTS.equals(type)) {
            throw new IllegalArgumentException("'" + type + "' is not a valid script type.");
        }
        FacesContext context = FacesContext.getCurrentInstance();
        Set<String> scripts = (LinkedHashSet<String>) context.getExternalContext().getRequestMap().get(type);
        if (scripts == null) {
            scripts = new LinkedHashSet<String>();
            context.getExternalContext().getRequestMap().put(type, scripts);
        }

        return scripts;
    }

    @SuppressWarnings("unchecked")
    public static Set<String> getCss(String type) {
        if (!EXTERNAL_STYLESHEETS.equals(type) && !INLINE_STYLESHEET.equals(type)) {
            throw new IllegalArgumentException("'" + type + "' is not a valid CSS type.");
        }
        FacesContext context = FacesContext.getCurrentInstance();
        Set<String> styleSheets = (LinkedHashSet<String>) context.getExternalContext().getRequestMap().get(type);
        if (styleSheets == null) {
            styleSheets = new LinkedHashSet<String>();
            context.getExternalContext().getRequestMap().put(type, styleSheets);
        }

        return styleSheets;
    }

    @SuppressWarnings("unchecked")
    public static Map<String, String> getMeta() {
        //TODO: One of these is not like the others...
        FacesContext context = FacesContext.getCurrentInstance();
        Map<String, String> metaTags =
                (Map<String, String>) context.getExternalContext().getRequestMap().get(META_TAGS);
        if (metaTags == null) {
            context.getExternalContext().getRequestMap().put(META_TAGS, new HashMap<String, String>());
        }

        return metaTags;
    }

    public static void addScript(String type, String script) {
        Set<String> scripts = getScripts(type);
        getScripts(type).add(script);
    }

    public static void addCss(String type, String css) {
        getCss(type).add(css);
    }

    @SuppressWarnings("unchecked")
    public static void addMeta(String name, String content) {
        getMeta().put(name, content);
    }
}