/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.sun.mojarra.scales.component;

import com.sun.mojarra.scales.util.RenderingHelper;
import com.sun.mojarra.scales.util.ScalesUtil;
import java.io.IOException;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

/**
 * This class will now serve as the base class for all Scales components.  The
 * design is likely less than optimal, but should serve adequately until Scales
 * can migrate to JSF 2.  In the meantime, this class will simplify the build
 * environment and remove a run-time dependency, both of which I think are noble
 * goals.
 *
 * @author Jason Lee
 */
public class ScalesOutputComponent extends UIOutput {
    protected String templateFile = null;
    protected String templateText;

    private Object[] _state = null;

    @Override
    public void encodeBegin(FacesContext context) throws IOException {
        if (templateFile == null) {
            super.encodeBegin(context);
            return;
        }
        if (context == null) {
            throw new NullPointerException("param 'context' is null");
        }

        // suppress rendering if "rendered" property on the component is false.
        if (!isRendered()) {
            return;
        }
        templateText = RenderingHelper.loadTemplateText(this, templateFile);
        ResponseWriter writer = context.getResponseWriter();
        String beforeText = RenderingHelper.getBeforeText(templateText);
        writer.write(beforeText);
    }

    @Override
    public void encodeEnd(FacesContext context) throws IOException {
        if (templateFile == null) {
            super.encodeEnd(context);
            return;
        }
        ResponseWriter writer = context.getResponseWriter();
        String afterText = RenderingHelper.getAfterText(templateText);
        writer.write(afterText);
    }

    @Override
    public boolean getRendersChildren() {
        if (templateFile == null) {
            return super.getRendersChildren();
        } else {
            return false;
        }
    }

    protected void setTemplateFile(String fileName) {
        this.templateFile = fileName;
    }
}